;(function($){

/**
 * Common constructor
 **/
$.ejswidget = function(id, type, opt) {

	this.id = id;
	
	//Checking existing instance
	var wg = $.ejswidget._wg[id];
	if (wg) {
	  wg.destroy();
	  delete $.ejswidget._wg[id];
	}

	//Inheriting runtime options
	this.opt = $.extend(true, {}, $.ejswidget[ type ].prototype.opt||{}, opt);
	
	if (this.onCreate)
		this.onCreate();
};

$.extend($.ejswidget.prototype, {

	id :undefined,

  type : undefined,
  
  opt : {
		
	},

	cast : function(_to) {
		return $.ejswidget._proto[_to];
	},
	
	//Creates url to a widget action
	createUrl : function(action, opt) {

		opt = $.extend({
			"class" : this.type,
		}, this.opt, opt||{});
		
		delete opt.baseUrl;
		delete opt.portletAction;
		//TODO: delete non-member atributes
		
		var controller = opt.widgetController;

		return this.opt.baseUrl.replace(/\/+(\w+\.php)?$/, '') + "/?r=" + controller + "/" + this.type.toLowerCase() + "." + action 
			+ "&w=" + encodeURIComponent(JSON.stringify(opt));
	},
	
	//Overridable : initialization
	onCreate : function () {

	},

	//Overridable : cleanup
	destroy : function() {

	}
  
});




/**
 * Factory for creating widget types + instances
**/
$.extend($.ejswidget, {
	
	//Widget instances
	_wg : {},	

	//Prototype instances
	_proto : {},
	
	//Getter to widget instances
	get : function(id) {
		return $.ejswidget._wg[id];
	},
	
/**
 * Creating a widget type
**/
	define : function(type, widget, baseWidget) {

		//Constructor for the new class
		this[type] = function(id, opt) {
			$.ejswidget.call(this,id,type,opt||{});
		};
		
		//Preparing prototype of the new widget type
		if (!baseWidget)
			baseWidget = $.ejswidget.prototype;
		else
			if (typeof baseWidget == "string")
				baseWidget = $.ejswidget[baseWidget].prototype;

		$.extend(true,
			this[type].prototype,
			baseWidget,
			widget, 
			{
				type : type
			}
		);
		
		//Registering prototype
		this._proto[type] = this[type].prototype;
	},

/**
 * Creating a widget instance
**/
	create : function(type, id, opt) {
		if (!this[type]) {
			console.error('no [' + type + '] widget defined!');
			return null;
		}
		return this._wg[id] = new this[type]( id||opt["id"], opt);
	}

});

})(jQuery);
