<?php
/**
 * EXPERIMENTAL
 * Base class for widgets to use "self actions".
 * 
 * A self action is a widget method named actionXYZ, my own term, sorry if you find it ugly or confusing.
 * It's similar to a controller's inline action.
 * 
 * A controller is required to "host" and route the self actions.
 * In that controller, the actions() method should be like this:

public function actions() {
	return EJsWidgetBehavior::controllerActions(array(
		'application.widgets.ecalculator.ECalculatorWidget',
		'application.widgets.efancycalculator.EFancyCalculatorWidget',
		...
	));
}

That way, the widget will be able to call itself, its "self action" methods named like widget->actionXYZ

SEE THE DEMO to understand how that works.

**/
class ESimpleActionWidget extends CWidget {
	
	public $widgetController;

	public function runWithParams($params) {
		return EJsWidgetBehavior::runWithParams($this, $params);
	}


/** 
 * Returns an array like this:
return array(
	'add' => array(
		'class'=>__CLASS__,
		'id'=>$_REQUEST['id'],
		...
	),
	...
);
*/
	public static function actions() {
		return EJsWidgetBehavior::widgetActions(get_called_class());
	}
}
